#/usr/bin/env python


#Import Modoules
import os, profile
import pygame, pygame.font, pygame.image, pygame.mixer, pygame.time, pygame.transform
from pygame.locals import *
import math
from random import *



# the global

class Score:
    def __init__(self):
        self.score = 0

       

class Console:
    def __init__(self, font, color=(255,255,255)):
        self.clear()
        self.font = font
        self.color = color
        pass

    def blit_on(self, surface):
        for i in self.lines:
            text = self.font.render(i,0,self.color)
            surface.blit(text, (self.x_pos, self.y_pos))
            self.y_pos = self.y_pos + text.get_height()


    def add_line(self, text):
        self.lines.append(text)


    def clear(self):
        self.lines = []
        self.x_pos = 0
        self.y_pos = 0

class Space:
    def __init__(self,screen, x_size, y_size):
        self.objects = []
        self.screen = screen
        self.x_size = x_size
        self.y_size = y_size
        self.dirty = []
        self.resources = {}
        self.remove_list = []
        self.score = 0
        self.level=1
        self.max_speed = 50
        self.dirtyrectlist=[(0,0,self.x_size,self.y_size)]
        self.subrect_factor = 0.5

    def reinit(self):
        self.objects = []
        self.dirty = []
        self.remove_list = []
        self.dirtyrectlist=[(0,0,self.x_size,self.y_size)]
        

    def resize(self, x_size, y_size):
        self.x_size = x_size
        self.y_size = y_size


    def add_object(self, object):
        self.objects.append(object)

    def remove_object(self, object):
        if not object in self.objects:
            self.remove_list.append(object)

    def step(self, step_size, center_object):
        if self.dirtyrectlist == None:
            return
        self.objcount = 0
        x_center = center_object.x
        y_center = center_object.y
        for i in self.objects:
        # we never leave visivility
##            if (i.x > x_center + self.x_size/2) or (i.x < x_center - self.x_size/2) \
##               or (i.y > y_center + self.y_size/2) or (i.y < y_center - self.y_size/2):            
##                self.objects.remove(i)
##            else:
                i.step(step_size)
                if i.is_alive():
                    self.objcount += 1
                else:
                    self.objects.remove(i)
        oldrectlist = []
        rectlist = []

        # obtengo los rectangulos
        for i in self.objects:
            oldrectlist.append(i.get_rotated().get_rect())

        for i in range(len(self.objects)):
            xs = oldrectlist[i][1]-oldrectlist[i][0]
            ys = oldrectlist[i][3]-oldrectlist[i][2]
            rectlist.append(Rect((self.objects[i].x-oldrectlist[i][2]/2, self.objects[i].y-oldrectlist[i][3]/2, oldrectlist[i][2], oldrectlist[i][3])))

        temp_rectlist = rectlist
        rectlist = []
        for i in temp_rectlist:
            rectlist.append(Rect( (i[0]+i[2]*(1-self.subrect_factor)/2, i[1]+i[3]*(1-self.subrect_factor)/2, i[2]*self.subrect_factor, i[3]*self.subrect_factor) ))
        
        for i in range(len(self.objects)):
            if self.objects[i].crashable and self.objects[i].is_alive():
                for o in range(i,len(rectlist)):
                    if self.objects[o].crashable and self.objects[i].is_alive():
                        if o != i:
                            if rectlist[i].colliderect(rectlist[o]):
                                if self.objects[i].will_collide(self.objects[o]) and self.objects[o].will_collide(self.objects[i]):        
                                        swpx = self.objects[i].vel_x * self.objects[i].mass /self.objects[o].mass
                                        swpy = self.objects[i].vel_y * self.objects[i].mass /self.objects[o].mass
                                        self.objects[i].vel_x = self.objects[o].vel_x * self.objects[o].mass / self.objects[i].mass
                                        self.objects[i].vel_y = self.objects[o].vel_y * self.objects[o].mass /self.objects[i].mass
                                        self.objects[o].vel_x = swpx
                                        self.objects[o].vel_y = swpy
                                        self.objects[i].step(100)
                                        self.objects[o].step(100)
                                        self.objects[i].crash(self.objects[o])
                                        self.objects[o].crash(self.objects[i])

    
        for i in range(len(self.remove_list)):
                self.objects.remove(self.remove_list[i])
        self.remove_list = []
        

    def draw(self, center_x, center_y):
        if self.dirtyrectlist != None:
            self.olddirtyrectlist = self.dirtyrectlist
        else:
            self.olddirtyrectlist = []
        self.dirtyrectlist = []
        for i in self.objects:
            a = i.get_corner(i.x-center_x+self.x_size/2, i.y-center_y+self.y_size/2)
            b = i.get_rotated()
            self.screen.blit(b, a)
            self.dirtyrectlist.append((a[0], a[1], b.get_width(), b.get_height()))

class rotated_image:
    def __init__(self, file_image):
        self.img = pygame.image.load(file_image).convert()
        self.img.set_colorkey(self.img.get_at((0, 0)))
        

    def scale(self, scale):
        self.img = pygame.transform.scale(self.img, ((self.img.get_width()/scale), (self.img.get_height()/scale)))
        
    def make_rotations(self, deg_scale = 10):
        self.deg_scale = deg_scale
        self.rotated = []
        for i in range(0, 360, deg_scale):
            self.rotated.append(pygame.transform.rotate(self.img, i))

    def get_rotated(self, dir):
        return self.rotated[ int(dir / self.deg_scale) ]

    def get_corner(self, x, y, dir):
        image = self.get_rotated(dir)
        x = x - image.get_width()/2
        y = y - image.get_height()/2
        return (x, y)

    

   
class space_object:
    def __init__(self, x=0, y=0, dir=0):
        # units are in degrees, pixels, and per second
        self.x = x
        self.y = y
        self.dir = dir
        self.rotation_speed = 0
        self.vel_x = self.vel_y = 0
        self.mass = 50
        self.energy = 200
        self.collisions = []
        self.crashable = 1
        self.alive = 1


    def will_collide(self, o ):
        return 1
    
    def crash(self, against):
        self.energy = self.energy - math.sqrt(against.vel_x*against.mass*against.vel_x*against.mass + against.vel_y*against.mass*against.mass*against.vel_y )
        if self.energy < 0:
            self.alive = 0
            world.remove_object(self)
        
    def set_image(self, oimage):
        self.image = oimage

    def is_alive(self):
        return self.alive
        
    
    def accelerate(self, accel):
        self.vel_x = self.vel_x + (math.sin(self.dir*2*math.pi/360)*accel)
        self.vel_y = self.vel_y + (math.cos(self.dir*2*math.pi/360)*accel)

        
    def change_direction(self, change):
        if change < 0:
            change = 360 - ( divmod( abs(change), 360 ) )[1]
        self.dir = divmod(self.dir + change, 360)[1]

    def get_corner(self, x, y):
        return self.image.get_corner(x, y, self.dir)

    def get_rotated(self): 
        return self.image.get_rotated(self.dir)

    max_speed = 10
    def step(self, time_step):
        # change position due to velocity
        abs_vel = 0.0
        abs_vel += pow(self.vel_x,2)+ pow(self.vel_y,2) 
        if abs_vel > pow(self.max_speed,2):
            ratio = pow(self.max_speed,2)/abs_vel 
            self.vel_x *= ratio
            self.vel_y *= ratio
        

        self.x+=self.vel_x
        self.y+=self.vel_y

        if self.x > world.x_size/2:
            self.x = -world.x_size/2
        elif self.x < -world.x_size/2:
            self.x = world.x_size/2
        if self.y > world.y_size/2:
            self.y = -world.y_size/2
        elif self.y < -world.y_size/2:
            self.y = world.y_size/2



x_size = 800
y_size = 600
pygame.init()
screen = pygame.display.set_mode((x_size, y_size), 0)

world = Space(screen, x_size, y_size)
