
#Import Modoules
import os, profile
import pygame, pygame.font, pygame.image, pygame.mixer, pygame.time, pygame.transform
from pygame.locals import *
import math
from random import *
from engine import *

import __main__


class missile(space_object):
    def __init__(self):
        space_object.__init__(self)
        self.set_image(world.resources['fire'])
        self.mass = 5
        self.energy = 5
        self.life = 1200
        self.power = 5001

    def step(self, ms):
        self.x = self.x + self.vel_x
        self.y = self.y + self.vel_y


        if abs(self.x) > world.x_size/2:
            self.x = -self.x
        if abs(self.y) > world.y_size/2:
            self.y = -self.y

        self.life -= ms
        if self.life < 0:
            self.alive =0

    def crash(self, against):
        self.alive = 0
        against.energy = against.energy - self.power
        world.add_object(Crash(self.x, self.y))

class asteroid(space_object):
    def __init__(self, as_size = 1):
        space_object.__init__(self)
        if as_size == 1:
            self.set_image(world.resources['asteroid-%i' % (randrange(3)+1)])
        elif as_size == 2:
            self.set_image(world.resources['asteroid-small-%i'% (randrange(3)+1)])
        elif as_size == 4:
            self.set_image(world.resources['asteroid-tiny-%i'% (randrange(3)+1)])
        self.as_size = as_size
        self.energy = 5000
        self.dir_change = randrange(7)/100 - 0.04
    
    def step(self, ms):
        space_object.step(self,ms)
        self.change_direction(self.dir_change*ms)

    def crash(self, against):
        space_object.crash(self, against)
        if ( self.energy < 0 and self.as_size < 4):
            world.score = world.score + 1000 * self.as_size
            minia1 = asteroid(self.as_size*2)
            minia2 = asteroid(self.as_size*2)
            sdif = 40
            minia1.x = self.x + sdif
            minia1.y = self.y + sdif
            minia2.x = self.x - sdif
            minia2.y = self.y - sdif
            minia1.vel_x = randrange(__main__.as_vel) 
            minia1.vel_y = randrange(__main__.as_vel) 
            minia2.vel_x = -minia1.vel_x
            minia2.vel_y = -minia1.vel_y            
            world.add_object(minia1)
            world.add_object(minia2)
            minia1.mass = minia2.mass = self.mass /2
            

class Ship(space_object):
    def  __init__(self, ship_file, rotations=0):
        space_object.__init__(self)
        self.set_image(rotated_image(ship_file))
        if rotations != 0:
            self.image.make_rotations(rotations)
        else:
            self.image.make_rotations()
        self.energy = self.start_energy = 1500
        self.mass = 50
        self.shots_p_sec = 5
        self.last_fired=0

    def crash(self, against):
        space_object.crash(self, against)
        world.add_object(Crash(self.x, self.y))
        if not self.alive:
            world.add_object(Crash(self.x+25, self.y+15))
            world.add_object(Crash(self.x+15, self.y-30))
            world.add_object(Crash(self.x, self.y-25))            
            world.add_object(Crash(self.x, self.y+35))
            world.add_object(Crash(self.x-35, self.y+10))

    def will_collide(self, o):
        if o.__class__ == missile:
            return 0
        else:
            return 1

class Crash(space_object):
    def __init__(self, x, y):
        space_object.__init__(self)
        self.time = 0
        self.x = x
        self.y = y
        self.set_image(world.resources['crash-1'])
        self.crashable = 0
        self.max_time = 200
        
    def is_alive(self):
        if self.time > self.max_time:
            return 0
        else:
            return 1
        
    def step(self, time):
        self.time = self.time + time
        if self.time > self.max_time/4*3:
            self.set_image(world.resources['crash-4'])
        elif self.time > self.max_time/4*2:
            self.set_image(world.resources['crash-3'])
        elif self.time > self.max_time/4:
            self.set_image(world.resources['crash-2'])
