#/usr/bin/env python


#Import Modoules
import os, profile
import pygame, pygame.font, pygame.image, pygame.mixer, pygame.time, pygame.transform
from pygame.locals import *
import math
from random import *
from engine import *
from objects import *
import levels

import __main__
__main__.as_vel = 60
#Resource Filenames


ship_file = os.path.join('ship.bmp')
fire_file = os.path.join('fire.bmp')
asteroid_file_1 = os.path.join('x-ast-1.bmp')
asteroid_file_2 = os.path.join('x-ast-2.bmp')
asteroid_file_3 = os.path.join('x-ast-3.bmp')
asteroid_file_small_1 = os.path.join('x-ast-small-1.bmp')
asteroid_file_small_2 = os.path.join('x-ast-small-2.bmp')
asteroid_file_small_3 = os.path.join('x-ast-small-3.bmp')
asteroid_file_tiny_1 = os.path.join('x-ast-tiny-1.bmp')
asteroid_file_tiny_2 = os.path.join('x-ast-tiny-2.bmp')
asteroid_file_tiny_3 = os.path.join('x-ast-tiny-3.bmp')
crash_file_1 = os.path.join('explosion-stage-1.bmp')
crash_file_2 = os.path.join('explosion-stage-2.bmp')
crash_file_3 = os.path.join('explosion-stage-3.bmp')
crash_file_4 = os.path.join('explosion-stage-4.bmp')
back_file = os.path.join('spaceback.bmp')
moon_file = os.path.join('moon.bmp')
earth_file = os.path.join('earth.bmp')
title_file = os.path.join('title.bmp')








class my_trace:
    def __init__(self):
        self.clocks = {}

    def start(self):
        self.last = 0
        self.time = pygame.time.get_ticks()

    def step(self):
        if not self.clocks.has_key(str(self.last)):
            self.clocks[str(self.last)] = 0
        self.clocks[str(self.last)] += pygame.time.get_ticks() - self.time
        self.time = pygame.time.get_ticks()
        self.last = self.last + 1


    def show(self):
        for i in self.clocks.keys():
            print "Block %s: %i ticks" % (i, self.clocks[i])


def main_screen(background):
        screen.blit(background, (0, 0))
            
        text = world.resources['title_font'].render("PySTEROIDS!",0,(250, 250, 250))
        screen.blit(world.resources['title'], (x_size/16, y_size/6))
        msg = world.resources['msg_font'].render("   Press any key to start, Esc to exit",0,(250, 250, 250))
        screen.blit(msg, (x_size/8, y_size/3*2))
        pygame.display.flip()
        doexit = 0
        
        while 1:
            event = pygame.event.poll()
            if event.type == QUIT or (event.type == KEYDOWN and event.key == K_ESCAPE):
                doexit = 1
                break
            if event.type == QUIT or (event.type == KEYDOWN):
                break

        if doexit:
            return 0
        else:
            return 1
    





def main():

#define config
    count_fps = 1
    fcurr_time = 2
    fstart_time = 1
    frame_time = 0
    force_fps = 30 # 0 = dont force FPS
    if force_fps:
        milisecff = 1000 / force_fps
    else:
        milisecff = 1000 / 15
    turn_p_sec = 400
    turn_sensibility = milisecff * turn_p_sec / 1000.0
    missile_speed = 40
    asteroid_speed = 800
    accel_p_sec = 10
    print milisecff, milisecff * accel_p_sec ,milisecff * accel_p_sec / 1000
    accel_sensibility = milisecff * accel_p_sec / 1000.0
    hi_score = Score()

#Initialize Everything
    
    pygame.display.set_caption('Pysteroids')
    pygame.mouse.set_visible(0)
    font = pygame.font.Font(None, 18)
    title_font = pygame.font.Font(None, 130)
    world.resources['title_font'] = title_font
    world.resources['msg_font'] = msg_font = pygame.font.Font(None, 48)
    console = Console(font)
    

#Create The Backgound
    background = pygame.Surface(screen.get_size())
    background.fill((10, 10, 10))

#Display The Background While Setup Finishes
    screen.blit(background, (0, 0))
    pygame.display.flip()

#Load Resources


    title_image = pygame.image.load(title_file).convert()
    title_image.set_colorkey(title_image.get_at((0, 0)))
    world.resources['title'] = title_image
    back_image = pygame.image.load(back_file).convert()
    world.resources['background'] = back_image
    earth_image = pygame.image.load(earth_file).convert()
    moon_image = pygame.image.load(moon_file).convert()
    moon_image.set_colorkey(moon_image.get_at((0, 0)))
    earth_image.set_colorkey(earth_image.get_at((0, 0)))
    
    fire_image = rotated_image(fire_file)
    fire_image.make_rotations()
    world.resources['fire'] = fire_image
    
    asteroid_image = rotated_image(asteroid_file_1)
    asteroid_image.make_rotations(1)
    world.resources['asteroid-1'] = asteroid_image
    asteroid_image = rotated_image(asteroid_file_2)
    asteroid_image.make_rotations(1)
    world.resources['asteroid-2'] = asteroid_image
    asteroid_image = rotated_image(asteroid_file_3)
    asteroid_image.make_rotations(1)
    world.resources['asteroid-3'] = asteroid_image

    asteroid_image = rotated_image(asteroid_file_small_1)
    asteroid_image.make_rotations(10)
    world.resources['asteroid-small-1'] = asteroid_image
    asteroid_image = rotated_image(asteroid_file_small_2)
    asteroid_image.make_rotations(10)
    world.resources['asteroid-small-2'] = asteroid_image
    asteroid_image = rotated_image(asteroid_file_small_3)
    asteroid_image.make_rotations(10)
    world.resources['asteroid-small-3'] = asteroid_image

    asteroid_image = rotated_image(asteroid_file_tiny_1)
    asteroid_image.make_rotations(10)
    world.resources['asteroid-tiny-1'] = asteroid_image
    asteroid_image = rotated_image(asteroid_file_tiny_2)
    asteroid_image.make_rotations(10)
    world.resources['asteroid-tiny-2'] = asteroid_image
    asteroid_image = rotated_image(asteroid_file_tiny_3)
    asteroid_image.make_rotations(10)
    world.resources['asteroid-tiny-3'] = asteroid_image

    print "done"
    crash_image = rotated_image(crash_file_1)
    crash_image.make_rotations(60)
    world.resources['crash-1'] = crash_image

    crash_image = rotated_image(crash_file_2)
    crash_image.make_rotations(60)
    world.resources['crash-2'] = crash_image

    crash_image = rotated_image(crash_file_3)
    crash_image.make_rotations(60)
    world.resources['crash-3'] = crash_image

    crash_image = rotated_image(crash_file_4)
    crash_image.make_rotations(60)
    world.resources['crash-4'] = crash_image
    

    xz = back_image.get_width()
    yz = back_image.get_height()
    bi = back_image

#Main Loop
    while 1:
        world.reinit()
        my_ship = Ship(ship_file)
        world.add_object(my_ship)
        my_ship.x = 0
        my_ship.y = 0

        #draw background
        bx =  - divmod(my_ship.x, xz)[1]
        while bx < x_size:
            by =  -divmod(my_ship.y, yz)[1]
            while by < y_size:
                background.blit(back_image, (bx, by))
                by = by + yz
            bx = bx + xz

        if randrange(2):
            background.blit(earth_image,(randrange(x_size),randrange(y_size)))
            background.blit(moon_image,(randrange(x_size),randrange(y_size)))
        else:
            background.blit(moon_image,(randrange(x_size),randrange(y_size)))
            background.blit(earth_image,(randrange(x_size),randrange(y_size)))

        if main_screen(background) == 0:
            break
        

        world.level = world.score = 0
        while my_ship.is_alive():
            # clear stuff
            console.clear()

            if levels.end_level():
                levels.new_level(background, world.level)
                world.level += 1           
                world.add_object(my_ship)
            
            #Handle Input, Check For Quit
            event = pygame.event.poll()
            if event.type == QUIT or (event.type == KEYDOWN and event.key == K_ESCAPE):
                break

            if pygame.key.get_pressed()[K_LEFT]:
                my_ship.change_direction(turn_sensibility)
            elif pygame.key.get_pressed()[K_RIGHT]:
                my_ship.change_direction(-turn_sensibility)

            if pygame.key.get_pressed()[K_DOWN]:
                my_ship.accelerate(accel_sensibility)
            elif pygame.key.get_pressed()[K_UP]:
                my_ship.accelerate(-accel_sensibility)            
            if pygame.key.get_pressed()[K_TAB]:
                print "Space size: (%i,%i,%i,%i) " %(-world.x_size/2,-world.y_size/2,world.x_size/2,world.y_size/2)
                print "Object List:"
                for i in world.objects:
                    print "%s: (%i, %i)" % (i.__class__, i.x, i.y)
            if pygame.key.get_pressed()[K_SPACE]:
                if my_ship.last_fired + 1000/my_ship.shots_p_sec < pygame.time.get_ticks():
                    my_ship.last_fired = pygame.time.get_ticks()
                    fire = missile()

                    fire.x = my_ship.x 
                    fire.y = my_ship.y 
                    fire.dir = my_ship.dir
                    fire.speed_dir = my_ship.dir
                    fire.vel_x = my_ship.vel_x -(math.sin(my_ship.dir*2*math.pi/360)*missile_speed)
                    fire.vel_y = my_ship.vel_y -(math.cos(my_ship.dir*2*math.pi/360)*missile_speed)

                    world.add_object(fire)
                    fire.step(800)
            # update objects
            # create asteroids

##            #Move mouse
##            if pygame.mouse.get_focused():
##                pointerpos = pygame.mouse.get_pos()
##            else:
##                pointerpos = (x_size, y_size)
            
            # force FPS
            if ( force_fps ):
                ttime = pygame.time.get_ticks()
                pygame.time.delay(milisecff - (ttime - fstart_time))
                

            # count FPS
            if (count_fps): 
                fcurr_time = pygame.time.get_ticks()
                frame_time = fcurr_time - (fstart_time-1)
                


            if (count_fps):
                #print "FPS: %i " % (1000/(frame_time))
                fstart_time = pygame.time.get_ticks()
                console.add_line("FPS: %i" % ((1000/frame_time)))
            # draw !            
            #draw background

                    
         
            #draw objects
            screen.blit(background, (0, 0)) 
            my_ship.step(frame_time)
            world.step(frame_time, my_ship)
            world.draw(0, 0)
            console.add_line("Energy:   %i" % my_ship.energy)
            console.add_line("Score:    %i" % world.score)
            console.add_line("Level:    %i" % world.level)
            console.add_line("Hi Score: %i" % hi_score.score)                        
            console.blit_on(screen)
            pygame.display.update(world.dirtyrectlist + world.olddirtyrectlist + [(0,0,120,100)])


        text = title_font.render("GAME OVER",0,(250, 250, 250))
        screen.blit(text, (x_size/6, y_size/3))
        msg = msg_font.render("      Press any key to continue",0,(250, 250, 250))
        screen.blit(msg, (x_size/8, y_size/3*2))
        if hi_score.score < world.score:
            hi_score.score = world.score
        pygame.display.flip()
        while 1:
            event = pygame.event.poll()
            if event.type == QUIT or (event.type == KEYDOWN ):
                break




#this is python code to kickstart the program if not imported
if __name__ == '__main__':
    #profile.run('main()')
    main()

